<?php
/*
  $Id$

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2018 osCommerce

  Released under the GNU General Public License
*/

  class cm_login_form_blacklist {
    var $code;
    var $group;
    var $title;
    var $description;
    var $sort_order;
    var $enabled = false;

    function __construct() {
      $this->code = get_class($this);
      $this->group = basename(dirname(__FILE__));

      $this->title = MODULE_CONTENT_LOGIN_FORM_BLACKLIST_TITLE;
      $this->description = MODULE_CONTENT_LOGIN_FORM_BLACKLIST_DESCRIPTION;

      if ( defined('MODULE_CONTENT_LOGIN_FORM_BLACKLIST_STATUS') ) {
        $this->sort_order = MODULE_CONTENT_LOGIN_FORM_BLACKLIST_SORT_ORDER;
        $this->enabled = (MODULE_CONTENT_LOGIN_FORM_BLACKLIST_STATUS == 'True');
      }
    }

    function execute() {
      global $sessiontoken, $login_customer_id, $messageStack, $oscTemplate;

      $content_width = (int)MODULE_CONTENT_LOGIN_FORM_BLACKLIST_CONTENT_WIDTH;
      
      $error = false;

      /*** Begin Blaclist ***/     
      $error_blacklisted = false;
      /*** End Blaclist ***/ 

      if (isset($_GET['action']) && ($_GET['action'] == 'process') && isset($_POST['formid']) && ($_POST['formid'] == $sessiontoken)) {
        $email_address = tep_db_prepare_input($_POST['email_address']);
        $password = tep_db_prepare_input($_POST['password']);

// Check if email exists
        /*** Begin Blaclist ***/
        $customer_query = tep_db_query("select customers_id, customers_firstname, customers_lastname, customers_password from customers where customers_email_address = '" . tep_db_input($email_address) . "' limit 1");
        /*** End Blaclist ***/
        
        if (!tep_db_num_rows($customer_query)) {
          $error = true;
        } else {
          $customer = tep_db_fetch_array($customer_query);

// Check that password is good
          if (!tep_validate_password($password, $customer['customers_password'])) {
            $error = true;
          } else {
            /*** Begin Blaclist ***/ 
            $blacklist_query = tep_db_query("SELECT c.customers_id, b.customers_id, b.ban_customer, b.description FROM customers c, blacklist b WHERE b.customers_id = '" . (int)$customer['customers_id'] ."'");
            $blacklisted = tep_db_fetch_array($blacklist_query);

            if ($blacklisted['ban_customer'] == true) {
                $error = true;
                $error_blacklisted = true;
                
                tep_db_query("update blacklist set attempted_use = '1' where customers_id = '" . (int)$customer['customers_id'] . "'");

                $email_body = 'The following blacklisted person tried to login:' . "\n\n\t" . $customer['customers_firstname'] . ' ' . $customer['customers_lastname'];   
                tep_mail(STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS, 'Attempted login by blacklisted visitor', $email_body, STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);
            } else { 
            /*** End Blaclist ***/ 
      
// set $login_customer_id globally and perform post login code in catalog/login.php
            $login_customer_id = (int)$customer['customers_id'];

// migrate old hashed password to new phpass password
            if (tep_password_type($customer['customers_password']) != 'phpass') {
              tep_db_query("update customers set customers_password = '" . tep_encrypt_password($password) . "' where customers_id = '" . (int)$login_customer_id . "'");
            }
          }
          /*** Begin Blaclist ***/ 
          }
          /*** End Blaclist ***/ 
        }
      }

      if ($error == true) {
        /*** Begin Blaclist ***/ 
        if ($error_blacklisted == true)
           $messageStack->add('login', 'You have been banned from this site. Please contact the shop owner for further details.');
        else       
        /*** End Blaclist ***/ 
           $messageStack->add('login', MODULE_CONTENT_LOGIN_BLACKLIST_TEXT_LOGIN_BLACKLIST_ERROR);
      }

      ob_start();
      include('includes/modules/content/' . $this->group . '/templates/tpl_' . basename(__FILE__));
      $template = ob_get_clean();

      $oscTemplate->addContent($template, $this->group);
    }

    function isEnabled() {
      return $this->enabled;
    }

    function check() {
      return defined('MODULE_CONTENT_LOGIN_FORM_BLACKLIST_STATUS');
    }

    function install() {
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Login Form Blacklist Module', 'MODULE_CONTENT_LOGIN_FORM_BLACKLIST_STATUS', 'True', 'Do you want to enable the login form module?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Content Width', 'MODULE_CONTENT_LOGIN_FORM_BLACKLIST_CONTENT_WIDTH', '6', 'What width container should the content be shown in? (12 = full width, 6 = half width).', '6', '1', 'tep_cfg_select_option(array(\'12\', \'11\', \'10\', \'9\', \'8\', \'7\', \'6\', \'5\', \'4\', \'3\', \'2\', \'1\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_CONTENT_LOGIN_FORM_BLACKLIST_SORT_ORDER', '1000', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");
    }

    function remove() {
      tep_db_query("delete from configuration where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_CONTENT_LOGIN_FORM_BLACKLIST_STATUS', 'MODULE_CONTENT_LOGIN_FORM_BLACKLIST_CONTENT_WIDTH', 'MODULE_CONTENT_LOGIN_FORM_BLACKLIST_SORT_ORDER');
    }
  }
  