<?php
/*
  $Id: blacklist.php,v 1.4 2019/12/27 
  blacklist Originally Created by: Jack York from www.oscommerce-solution.com
  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2003 osCommerce

  Released under the GNU General Public License
*/
 
  require('includes/application_top.php');
  //require('includes/languages/' . $language . '/blacklist.php');
  $sort_order = 'customers_lastname';
  $checkedFirstName = $checkedLastName = '';
  
  /********************** BEGIN VERSION CHECKER *********************/
  if (file_exists('includes/functions/version_checker.php'))  {
      require('includes/languages/' . $language . '/version_checker.php');
      require('includes/functions/version_checker.php');
      $contribPath = 'https://apps.oscommerce.com/PvsYh';
      $currentVersion = 'Blacklist V 1.4';
      $contribName = 'Blacklist V';
      $versionStatus = '';
  }
  /********************** END VERSION CHECKER *********************/
 
  /********************** CHECK THE VERSION ***********************/
  if (isset($_POST['action']) && $_POST['action'] == 'getversion') {
      if (isset($_POST['version_check']) && $_POST['version_check'] == 'on') {
          $versionStatus = AnnounceVersion($contribPath, $currentVersion, $contribName);
      }    
  }
      
  if (isset($_POST['group1']) && $_POST['group1'] == 'first') {
    $checkedFirstName = ' checked=checked ';
  } else {
    $checkedLastName = ' checked=checked ';
  }
  
  $action = ($_POST['action'] ?? '');

  if (tep_not_null($action))   { 
      if (isset($_POST['add_cust_x'])) {
          $firstname = $lastname = '';
          $names = explode(" ", $_POST['customers']);       
          
          if (isset($names[2]) && tep_not_null($names[2])) { //for multi-parts names
              $cnt = count($names) - 1;
              for ($i = 0; $i < $cnt; ++$i) {
                  $firstname .= $names[$i] . ' '; 
              }
              $firstname = trim($firstname);
              $lastname = $names[$cnt];
          }
 
          $customer_id = (int)tep_db_input($_POST['customers']);
          $customers_query = tep_db_query("SELECT customers_firstname, customers_lastname FROM customers where customers_id = '" . $customer_id  . "'");
          $cust = tep_db_fetch_array($customers_query);
          $reason = $_POST['blacklist_reason']; 
          $ban = ($_POST['ban_customer'] == 'on') ? '1' : '0';
    
          tep_db_query("delete from blacklist where customers_id = '" . $customer_id . "'");
          $address_book_query = tep_db_query("SELECT entry_street_address, entry_suburb, entry_postcode, entry_city, entry_state, entry_zone_id FROM address_book where customers_id = '" . $customer_id  . "'");

          while($address = tep_db_fetch_array($address_book_query)) {
              if ($address['entry_zone_id'] != 0) {
                  $zone_query = tep_db_query("SELECT zone_name FROM zones where zone_id = '" . (int)$address['entry_zone_id'] . "'");
                  $zone_name = tep_db_fetch_array($zone_query);
                  $address['entry_state'] = $zone_name['zone_name'];
              }
            
              tep_db_query("insert into blacklist (customers_id, ban_customer, description, entry_street_address, entry_suburb, entry_postcode, entry_city, entry_state, date_added) values ('" . $customer_id . "', '" . tep_db_input($ban) . "', '" . tep_db_input($reason) . "', '" . tep_db_input($address['entry_street_address']) . "', '" . tep_db_input($address['entry_suburb']) . "', '" . tep_db_input($address['entry_postcode']) . "', '" . tep_db_input($address['entry_city']) . "', '" . tep_db_input($address['entry_state']) . "', now() )") or die('');
          }
      } else if (isset($_POST['delete_cust_x'])) {
          tep_db_query("delete from blacklist where customers_id = '" . (int)tep_db_input($_POST['blacklist']) . "'");
      }
      $sort_order = ($checkedFirstName == ' checked=checked ' ? 'customers_firstname' : 'customers_lastname');  
  }
  
  $customers = array();
  $customers_query = tep_db_query("SELECT customers_id, customers_lastname FROM customers where customers_id NOT IN (select customers_id from blacklist) ORDER by " . $sort_order . " ASC");

  while ($list = tep_db_fetch_array($customers_query)) {
      $customer_name = tep_customers_name($list['customers_id']); 
      $customers[] = array('id' => $list['customers_id'], 'text' => $customer_name);
  }  

  $banned = '';
  $attempted_use = '';
  $reason_banned = '';
  $blackList = array();
  $blacklist_query = tep_db_query("SELECT c.customers_id, b.ban_customer, b.attempted_use, b.description FROM customers c left join blacklist b on c.customers_id = b.customers_id where b.ban_customer IS NOT NULL ORDER by " . $sort_order . " ASC");
 
  $ctr = 0;
  while ($list = tep_db_fetch_array($blacklist_query)) {
      $customer_name = tep_customers_name($list['customers_id']);            
       
      if (($ctr == 0 && !tep_not_null($_POST)) || (isset($_POST['blacklist']) && $list['customers_id'] === $_POST['blacklist']) || tep_db_num_rows($blacklist_query) == 1) {     
          if ($list['ban_customer'] == 1) {
             $banned = ' checked=checked ';
          } 
 
          if ($list['attempted_use'] == '1') {
              $attempted_use = ' checked=checked ';  
          }
          $reason_banned = $list['description'];
      }
      $ctr++;
      $blackList[] = array('id' => $list['customers_id'], 'text' => $customer_name);
  } 

  require('includes/template_top.php'); 
?>
 

<style>
.boxit { border:1px solid gray }
.do-small { float:right; font-size:12px; font-weight:bold; color:#ff0000 }
.do-small-inline { display:inline-block; font-size:12px; font-weight:bold; color:#ff0000; vertical-align:middle }
.vc-container { padding:10px 5px 25px; vertical-align:middle }
.bl-sort-container { padding:15px 10px; border-top:2px solid #000; border-bottom:2px solid #000 }
.bl-sort { display:inline-block; width:120px }
.bl-container { border:1px solid gray; margin:15px 10px 15px 0px }
.bl-left, .bl-right { padding:15px; vertical-align:top; font-size:13px; height:310px }
.bl-heading { color:sienna; font-size:14px; text-align:center; padding-bottom:15px }
.bl-label { width:145px; padding-right:40px; font-weight:bold; white-space:nowrap }
.bl-label, .bl-input-content { padding-top:15px; vertical-align:top }
.bl-button { padding-top:20px; text-align:center; vertical-align:bottom }
.bl-details { border-top:2px solid #000; padding-top:15px; margin-bottom:50px }
</style>

<div class="vc-container">
  <div style="display:inline-block">
    <div class="pageHeading"><?php echo str_replace(" ", "&nbsp;", $currentVersion); ?></div>
    <div class="smallText"><?php echo HEADING_TITLE_SUPPORT_THREAD; ?></div>
  </div>

  <div style="display:inline-block; float:right">
    <div class="smallText" style="text-align:right; margin-bottom:10px"><?php echo HEADING_TITLE_AUTHOR; ?></div>

<?php  
  if (function_exists('AnnounceVersion')) {
      $idParts = explode(' ', $currentVersion);
      $name = '';
      foreach ($idParts as $part) {
          if ($part !== 'V') {
              $name .= $part;
          } else {
              break;
          }               
      }
      $id = $idParts[count($idParts) - 1];
      if (true) { 
    ?> 
    <div class="smallText do-small" style="text-align:right"><?php echo AnnounceVersion($contribPath, $currentVersion, $contribName) . ' '; ?><input class="vertAlign" type="radio" name="version_check_unreleased" onClick="window.open('http://www.oscommerce-solution.com/check_unreleased_updates.php?id=<?php echo $id; ?>&name=<?php echo $name; ?>')"><?php echo TEXT_VERSION_CHECK_UPDATES_UNRELEASED; ?></div>
    <?php 
      } elseif (tep_not_null($versionStatus)) { 
          echo '    <div class="do-small">' . $versionStatus . '</div>' . "\n";
      } else {
          echo tep_draw_form('version_check', 'blacklist.php', '', 'post') . tep_draw_hidden_field('action', 'getversion');
?>

    <div class="do-small-inline"><input class="vertAlign" type="radio" name="version_check" onClick="this.form.submit();"><?php echo TEXT_VERSION_CHECK_UPDATES . ' '; ?></div>
    <div class="do-small-inline"><input class="vertAlign" type="radio" name="version_check_unreleased" onClick="window.open('http://www.oscommerce-solution.com/check_unreleased_updates.php?id=<?php echo $id; ?>&name=<?php echo $name; ?>')"><?php echo TEXT_VERSION_CHECK_UPDATES_UNRELEASED; ?></div></form>
             
<?php 
      }
  } else {
?>

    <div class="do-small"><?php echo TEXT_MISSING_VERSION_CHECKER; ?></div>
          
<?php 
  }
?>

  </div> 
</div> 
           
<!-- Begin of Blacklist -->

<?php echo tep_draw_form('blacklist_controller', 'blacklist.php', '', 'post') . tep_draw_hidden_field('action', 'process');
?>

<div class="bl-sort-container">            
  <div class="bl-sort"><?php echo TEXT_SORT_BY; ?></div> 
  <div class="bl-sort"><label><input type="radio" name="group1" value="first" <?php echo $checkedFirstName; ?> onclick="this.form.submit();"> First Name</label></div>
  <div class="bl-sort"><label><input type="radio" name="group1" value="last" <?php echo $checkedLastName; ?> onclick="this.form.submit();"> Last Name</label></div>
</div>

<div class="bl-container">
<table width="100%" cellpadding="2">
  <tr>
    <td width="45%" class="bl-left boxit">
      <div class="bl-heading"><?php echo TEXT_ALL_CUSTOMERS; ?></div>
      <table width="100%" height="100%">
        <tr>
          <td class="bl-label"><?php echo TEXT_CUSTOMERS_ALL; ?></td>
          <td class="bl-input-content"><?php echo tep_not_null($customers) ? tep_draw_pull_down_menu('customers', $customers, '', 'style="width:180px"') : '<span style="color:red">There are no registered customers</span>'; ?></td>
        </tr>
        <tr>
          <td class="bl-label"><?php echo TEXT_BAN_COMPLETLY; ?></td> 
          <td class="bl-input-content"><?php echo tep_draw_checkbox_field('ban_customer', '', false, 'onChange="this.form.submit();"'); ?></td>
        </tr>
        <tr>
          <td class="bl-label"><?php echo TEXT_BAN_REASON; ?></td>
          <td class="bl-input-content"><?php echo tep_draw_textarea_field('blacklist_reason', 'soft', 30, 5, '', 'style="padding:7px"'); ?></td>
        </tr>
        <tr>
          <td colspan="2" class="bl-button"><input type=image src="includes/languages/english/images/buttons/button_update.gif" name="add_cust"></td>
        </tr>
      </table></td>
      
    <td width="50%" class="bl-right boxit">
      <div class="bl-heading"><?php echo TEXT_BANNED_CUSTOMERS; ?></div>
      <table width="100%" height="100%">
        <tr>
          <td class="bl-label"><?php echo TEXT_CUSTOMERS_BLACKLISTED; ?></td>
          <td class="bl-input-content"><?php echo tep_not_null($blackList) ? tep_draw_pull_down_menu('blacklist', $blackList, '', 'style="width:180px" onChange="this.form.submit();"') : '<span style="color:red">There are no banned customers</span>'; ?></td>
        </tr>
        <tr>
          <td class="bl-label"><?php echo TEXT_BANNED_COMPLETLY; ?></td>
          <td class="bl-input-content"><input type="checkbox" name="ban_customer_out" value="" <?php echo $banned; ?> onclick="return false;"></td>
        </tr>
        <tr>
          <td class="bl-label"><?php echo TEXT_HAS_ATTEMPTED; ?></td>
          <td class="bl-input-content"><input type="checkbox" name="attempted_use" value="" <?php echo $attempted_use; ?> onclick="return false;"></td>
        </tr>
        <tr>
          <td class="bl-label"><?php echo TEXT_BAN_REASON; ?></td>
          <td class="bl-input-content"><?php echo tep_draw_textarea_field('blacklist_reason_out', 'soft', 30, 5, stripslashes($reason_banned), 'style="padding:7px" readonly', false); ?></td>
        </tr>
        <tr>
          <td colspan="2" class="bl-button"><input type=image src="includes/languages/english/images/buttons/button_delete.gif" name="delete_cust"></td>
        </tr>
      </table></td>
  </tr>
</table></div>
</form> 

<div class="bl-details"><?php echo TEXT_BLACKLIST_DETAILS; ?></div>
<!-- end of Blacklist -->

<?php 
  require('includes/template_bottom.php');
  require('includes/application_bottom.php');
?>
